/*
 *
 *     Copyright (c) 2006, ClearSpeed Technology plc. All rights reserved.
 *
 * This material is provided "as is", with absolutely no warranty expressed or
 * implied. Any use is at your own risk. Permission to use or copy this software
 * for any purpose is hereby granted without fee, provided the above notices are
 * retained on all copies. Permission to modify the code and to distribute
 * modified code is granted, provided the above notices are retained, and a
 * notice that the code was modified is included with the above copyright notice.
 *
 */

///////////////////////////
// Start of code section //
///////////////////////////
.section .text

.align 32

/////////////////////
//                 //
//  Start program  //
//                 //
/////////////////////
_start::
.global _start
    endif;
    endif;
    endif;
    endif;
    endif;
    endif;
    endif;
    endif;
    j fft_compute;

// Used to drag in cfft1d etc
   j _start3;   // terminate thread
   j _start4;   // async thread
   j _start5;   // async thread

// Used to drag in boot_microcode routine
   j boot_microcode;

// Used to drag in core fft routines
   j CSDFT_create_plan_2d;

// Used to drag in host convolution routines
    j convolve_create_kernel;

    j cfft1D_128
    j cfft1D_256
    j cfft1D_512
    j cfft1D_1024
    j cfft1D_2048
    j cfft1D_4096
    j cfft1D_8192

    j cfft1D_double_128
    j cfft1D_double_256
    j cfft1D_double_512
    j cfft1D_double_1024
    j cfft1D_double_2048
    j cfft1D_double_4096
    j cfft1D_double_8192

    j cifft_postfft1D_128
    j cifft_postfft1D_256
    j cifft_postfft1D_512
    j cifft_postfft1D_1024
    j cifft_postfft1D_2048
    j cifft_postfft1D_4096
    j cifft_postfft1D_8192

    j cifft_postfft1D_double_128
    j cifft_postfft1D_double_256
    j cifft_postfft1D_double_512
    j cifft_postfft1D_double_1024
    j cifft_postfft1D_double_2048
    j cifft_postfft1D_double_4096
    j cifft_postfft1D_double_8192

// Drag in twiddle data
    j twiddle_128;
    j twiddle_256;
    j twiddle_512;
    j twiddle_1024;
    j twiddle_2048;
    j twiddle_4096;
    j twiddle_8192;

    j twiddle_double_128;
    j twiddle_double_256;
    j twiddle_double_512;
    j twiddle_double_1024;
    j twiddle_double_2048;
    j twiddle_double_4096;
    j twiddle_double_8192;

    j CSDFT_get_status;

// drag in cleard interface stuff

force_our_main::
.global force_our_main

/////////////////////////////////////////////
// Setting things for the dprint_* to work //
/////////////////////////////////////////////
.section .mono.bss
.align 16

__FRAME_BEGIN_MONO__::
.fill 0x1000, 1, 0         // Usual mono stack frame pointer for each thread
__FRAME_BEGIN_MONO__1::
.fill 0x100, 1, 0
__FRAME_BEGIN_MONO__2::
.fill 0x100, 1, 0
__FRAME_BEGIN_MONO__3::
.fill 0x100, 1, 0
__FRAME_BEGIN_MONO__4::
.fill 0x100, 1, 0
__FRAME_BEGIN_MONO__5::
.fill 0x100, 1, 0

    .global __FRAME_BEGIN_MONO__
    .global __FRAME_BEGIN_MONO__1
    .global __FRAME_BEGIN_MONO__2
    .global __FRAME_BEGIN_MONO__3
    .global __FRAME_BEGIN_MONO__4
    .global __FRAME_BEGIN_MONO__5

.section .poly.bss
.align 16

__FRAME_BEGIN_POLY__::
//.fill 0x20, 1, 0          // poly stack for each thread (64 bytes)
    .fill  5824+96-0x460, 1, 0x0
//.fill 96+8         // poly stack for each thread (104 bytes)
__FRAME_BEGIN_POLY__1::
.fill 0x00, 1, 0
__FRAME_BEGIN_POLY__2::
.fill 0x00, 1, 0
__FRAME_BEGIN_POLY__3::
.fill 0x00, 1, 0
__FRAME_BEGIN_POLY__4::
.fill 0x00, 1, 0
__FRAME_BEGIN_POLY__5::
.fill 0x00, 1, 0

    .global __FRAME_BEGIN_POLY__
    .global __FRAME_BEGIN_POLY__1
    .global __FRAME_BEGIN_POLY__2
    .global __FRAME_BEGIN_POLY__3
    .global __FRAME_BEGIN_POLY__4
    .global __FRAME_BEGIN_POLY__5


.section .mono.bss
.align 16
PRINT_AREA_CONTROL::
.fill 6, 1, 0x00
.align 16
PRINT_AREA_DATA::
.fill 2048, 4, 0x00 // 8 k of data enough to handle pe string prints
.align 16

.global PRINT_AREA_CONTROL
.global PRINT_AREA_DATA

/*
.section .poly.bss
.align 4
POLY_PRINT_AREA::
POLY_PRINT_ADDRESS::
.fill 1, 4, 0x00
POLY_PRINT_MASK::
.fill 2, 4, 0x00
POLY_DATA::
POLY_PRINT_DATA::
.fill 16, 4, 0x00

.global POLY_PRINT_AREA
.global POLY_PRINT_ADDRESS
.global POLY_PRINT_MASK
.global POLY_PRINT_DATA
*/
